/*
 * ASE1703.asm
 *
 *  Created: 21/02/2017 13.39.52
 *  Author: Roberto Roncella
 *
 *  Realizzare un sottoprogramma per il microcontrollore AVR XMEGA256A3BU,
 *  in grado di concatenare 2 stringhe poste in memoria rispettivamente 
 *  agli indirizzi 0x2000 e 0x2200; la stringa risultante andr posta in memoria 
 *  all'indirizzo 0x2400. 
 *  Una stringa, la cui massima lunghezza pu essere di 255 caratteri 
 *  (codici ASCII su 8 bit),  composta da un primo byte che contiene 
 *  l'indicazione della lunghezza della stringa stessa 
 *  (nel caso di stringa vuota l'indicazione di lunghezza  0) 
 *  seguito dai codici dei caratteri che compongono la stringa. 
 *  Se la stringa risultante superasse la massima lunghezza ammessa, 
 *  andr troncata ai primi 255 caratteri.
 */ 
main:
 rcall concatenate //solo per debug
 rjmp main

concatenate:
 push R16 //L1
 push R17 //L2
 push R18 //Ltot
 push R19 //ausiliario
 push XL //puntatore a stringa1
 push XH
 push YL //puntatore a stringa2
 push YH
 push ZL //puntatore al risultato
 push ZH
 ldi XL,low(0x2000)
 ldi XH,high(0x2000)
 ldi YL,low(0x2200)
 ldi YH,high(0x2200)
 ldi ZL,low(0x2400)
 ldi ZH,high(0x2400)
 ld R16,X+ //lunghezza della prima stringa L1
 ld R17,Y+ //lunghezza della seconda stringa L2
 mov R18,R16
 add R18,R17 //somma delle lunghezze Ltot=L1+L2
 brcc no_ov
ov: //Ltot>255
 ldi R18,255 //lunghezza della stringa risultato Ltot
 mov R17,R16 //modifica L2
 com R17 //il numero dei caratteri da copiare dalla seconda stringa e` L2=255-L1
no_ov: 
 st Z+,R18 //scrive Ltot
 tst R16 //controlla se L1=0
 breq step2
 s1:
  ld R19,X+
  st Z+,R19
  dec R16
  brne s1
step2:
 tst R17 //controlla se L2=0
 breq end
 s2:
  ld R19,Y+
  st Z+,R19
  dec R17
  brne s2
end:
 pop ZH //ripristina i registri modificati
 pop ZL
 pop YH
 pop YL
 pop XH
 pop XL
 pop R19
 pop R18
 pop R17
 pop R16
 ret